Index: /branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs	(revision 4764)
+++ /branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs	(revision 4765)
@@ -54,4 +54,6 @@
       this.label2 = new System.Windows.Forms.Label();
       this.splitContainer2 = new System.Windows.Forms.SplitContainer();
+      this.label4 = new System.Windows.Forms.Label();
+      this.operationTextBox = new System.Windows.Forms.TextBox();
       this.label3 = new System.Windows.Forms.Label();
       this.scopeTreeView = new System.Windows.Forms.TreeView();
@@ -60,6 +62,6 @@
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.parentButton = new System.Windows.Forms.Button();
-      this.operationTextBox = new System.Windows.Forms.TextBox();
-      this.label4 = new System.Windows.Forms.Label();
+      this.splitContainer3 = new System.Windows.Forms.SplitContainer();
+      this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
       this.splitContainer1.Panel1.SuspendLayout();
       this.splitContainer1.Panel2.SuspendLayout();
@@ -68,4 +70,7 @@
       this.splitContainer2.Panel2.SuspendLayout();
       this.splitContainer2.SuspendLayout();
+      this.splitContainer3.Panel1.SuspendLayout();
+      this.splitContainer3.Panel2.SuspendLayout();
+      this.splitContainer3.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -86,5 +91,5 @@
       this.executionTimeTextBox.Name = "executionTimeTextBox";
       this.executionTimeTextBox.ReadOnly = true;
-      this.executionTimeTextBox.Size = new System.Drawing.Size(496, 20);
+      this.executionTimeTextBox.Size = new System.Drawing.Size(684, 20);
       this.executionTimeTextBox.TabIndex = 1;
       // 
@@ -97,5 +102,5 @@
       this.logView.Name = "logView";
       this.logView.ReadOnly = false;
-      this.logView.Size = new System.Drawing.Size(339, 255);
+      this.logView.Size = new System.Drawing.Size(433, 237);
       this.logView.TabIndex = 2;
       // 
@@ -115,6 +120,6 @@
       // 
       this.splitContainer1.Panel2.Controls.Add(this.logView);
-      this.splitContainer1.Size = new System.Drawing.Size(339, 492);
-      this.splitContainer1.SplitterDistance = 233;
+      this.splitContainer1.Size = new System.Drawing.Size(433, 503);
+      this.splitContainer1.SplitterDistance = 262;
       this.splitContainer1.TabIndex = 3;
       // 
@@ -127,5 +132,5 @@
       this.executionStackTreeView.Name = "executionStackTreeView";
       this.executionStackTreeView.ShowNodeToolTips = true;
-      this.executionStackTreeView.Size = new System.Drawing.Size(333, 214);
+      this.executionStackTreeView.Size = new System.Drawing.Size(427, 243);
       this.executionStackTreeView.TabIndex = 2;
       this.executionStackTreeView.NodeMouseDoubleClick += new System.Windows.Forms.TreeNodeMouseClickEventHandler(this.executionStackTreeView_NodeMouseDoubleClick);
@@ -154,16 +159,32 @@
       // splitContainer2.Panel2
       // 
+      this.splitContainer2.Panel2.Controls.Add(this.splitContainer3);
       this.splitContainer2.Panel2.Controls.Add(this.label4);
       this.splitContainer2.Panel2.Controls.Add(this.operationTextBox);
-      this.splitContainer2.Panel2.Controls.Add(this.label3);
-      this.splitContainer2.Panel2.Controls.Add(this.scopeTreeView);
-      this.splitContainer2.Size = new System.Drawing.Size(678, 492);
-      this.splitContainer2.SplitterDistance = 339;
+      this.splitContainer2.Size = new System.Drawing.Size(866, 503);
+      this.splitContainer2.SplitterDistance = 433;
       this.splitContainer2.TabIndex = 0;
       // 
+      // label4
+      // 
+      this.label4.AutoSize = true;
+      this.label4.Location = new System.Drawing.Point(3, 6);
+      this.label4.Name = "label4";
+      this.label4.Size = new System.Drawing.Size(56, 13);
+      this.label4.TabIndex = 3;
+      this.label4.Text = "Operation:";
+      // 
+      // operationTextBox
+      // 
+      this.operationTextBox.Location = new System.Drawing.Point(65, 3);
+      this.operationTextBox.Name = "operationTextBox";
+      this.operationTextBox.ReadOnly = true;
+      this.operationTextBox.Size = new System.Drawing.Size(267, 20);
+      this.operationTextBox.TabIndex = 2;
+      // 
       // label3
       // 
       this.label3.AutoSize = true;
-      this.label3.Location = new System.Drawing.Point(3, 26);
+      this.label3.Location = new System.Drawing.Point(3, 0);
       this.label3.Name = "label3";
       this.label3.Size = new System.Drawing.Size(63, 13);
@@ -176,8 +197,8 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.scopeTreeView.Location = new System.Drawing.Point(3, 42);
+      this.scopeTreeView.Location = new System.Drawing.Point(3, 16);
       this.scopeTreeView.Name = "scopeTreeView";
       this.scopeTreeView.ShowNodeToolTips = true;
-      this.scopeTreeView.Size = new System.Drawing.Size(329, 447);
+      this.scopeTreeView.Size = new System.Drawing.Size(417, 216);
       this.scopeTreeView.TabIndex = 0;
       this.scopeTreeView.NodeMouseDoubleClick += new System.Windows.Forms.TreeNodeMouseClickEventHandler(this.scopeTreeView_NodeMouseDoubleClick);
@@ -187,5 +208,5 @@
       this.stepButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.stepButton.Image = ((System.Drawing.Image)(resources.GetObject("stepButton.Image")));
-      this.stepButton.Location = new System.Drawing.Point(624, 3);
+      this.stepButton.Location = new System.Drawing.Point(812, 3);
       this.stepButton.Name = "stepButton";
       this.stepButton.Size = new System.Drawing.Size(24, 24);
@@ -199,5 +220,5 @@
       this.updateButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.updateButton.Image = ((System.Drawing.Image)(resources.GetObject("updateButton.Image")));
-      this.updateButton.Location = new System.Drawing.Point(654, 3);
+      this.updateButton.Location = new System.Drawing.Point(842, 3);
       this.updateButton.Name = "updateButton";
       this.updateButton.Size = new System.Drawing.Size(24, 24);
@@ -211,5 +232,5 @@
       this.parentButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.parentButton.Image = ((System.Drawing.Image)(resources.GetObject("parentButton.Image")));
-      this.parentButton.Location = new System.Drawing.Point(594, 3);
+      this.parentButton.Location = new System.Drawing.Point(782, 3);
       this.parentButton.Name = "parentButton";
       this.parentButton.Size = new System.Drawing.Size(24, 24);
@@ -219,20 +240,35 @@
       this.parentButton.Click += new System.EventHandler(this.parentButton_Click);
       // 
-      // operationTextBox
-      // 
-      this.operationTextBox.Location = new System.Drawing.Point(65, 3);
-      this.operationTextBox.Name = "operationTextBox";
-      this.operationTextBox.ReadOnly = true;
-      this.operationTextBox.Size = new System.Drawing.Size(267, 20);
-      this.operationTextBox.TabIndex = 2;
-      // 
-      // label4
-      // 
-      this.label4.AutoSize = true;
-      this.label4.Location = new System.Drawing.Point(3, 6);
-      this.label4.Name = "label4";
-      this.label4.Size = new System.Drawing.Size(56, 13);
-      this.label4.TabIndex = 3;
-      this.label4.Text = "Operation:";
+      // splitContainer3
+      // 
+      this.splitContainer3.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.splitContainer3.Location = new System.Drawing.Point(3, 29);
+      this.splitContainer3.Name = "splitContainer3";
+      this.splitContainer3.Orientation = System.Windows.Forms.Orientation.Horizontal;
+      // 
+      // splitContainer3.Panel1
+      // 
+      this.splitContainer3.Panel1.Controls.Add(this.parameterCollectionView);
+      // 
+      // splitContainer3.Panel2
+      // 
+      this.splitContainer3.Panel2.Controls.Add(this.label3);
+      this.splitContainer3.Panel2.Controls.Add(this.scopeTreeView);
+      this.splitContainer3.Size = new System.Drawing.Size(423, 471);
+      this.splitContainer3.SplitterDistance = 235;
+      this.splitContainer3.TabIndex = 4;
+      // 
+      // parameterCollectionView
+      // 
+      this.parameterCollectionView.Caption = "ParameterCollection View";
+      this.parameterCollectionView.Content = null;
+      this.parameterCollectionView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.parameterCollectionView.Location = new System.Drawing.Point(0, 0);
+      this.parameterCollectionView.Name = "parameterCollectionView";
+      this.parameterCollectionView.ReadOnly = false;
+      this.parameterCollectionView.Size = new System.Drawing.Size(423, 235);
+      this.parameterCollectionView.TabIndex = 0;
       // 
       // DebugEngineView
@@ -246,5 +282,5 @@
       this.Controls.Add(this.label1);
       this.Name = "DebugEngineView";
-      this.Size = new System.Drawing.Size(684, 527);
+      this.Size = new System.Drawing.Size(872, 538);
       this.splitContainer1.Panel1.ResumeLayout(false);
       this.splitContainer1.Panel1.PerformLayout();
@@ -255,4 +291,8 @@
       this.splitContainer2.Panel2.PerformLayout();
       this.splitContainer2.ResumeLayout(false);
+      this.splitContainer3.Panel1.ResumeLayout(false);
+      this.splitContainer3.Panel2.ResumeLayout(false);
+      this.splitContainer3.Panel2.PerformLayout();
+      this.splitContainer3.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -277,4 +317,6 @@
     private System.Windows.Forms.Label label4;
     private System.Windows.Forms.TextBox operationTextBox;
+    private System.Windows.Forms.SplitContainer splitContainer3;
+    private Core.Views.ParameterCollectionView parameterCollectionView;
 
   }
Index: /branches/HeuristicLab.DebugEngine/DebugEngineView.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/DebugEngineView.cs	(revision 4764)
+++ /branches/HeuristicLab.DebugEngine/DebugEngineView.cs	(revision 4765)
@@ -129,4 +129,5 @@
       IAtomicOperation atomicOperation = operation as IAtomicOperation;
       operationTextBox.Text = "<none>";
+      parameterCollectionView.Content = null;
       toolTip.SetToolTip(operationTextBox, null);
       if (atomicOperation != null && atomicOperation.Operator != null) {
@@ -140,4 +141,5 @@
       IScope scope = null;
       if (context != null) {
+        parameterCollectionView.Content = context.Parameters;
         scope = context.Scope;
         while (scope != null && scope.Parent != null)
Index: /branches/HeuristicLab.DebugEngine/DebugEngineView.resx
===================================================================
--- /branches/HeuristicLab.DebugEngine/DebugEngineView.resx	(revision 4764)
+++ /branches/HeuristicLab.DebugEngine/DebugEngineView.resx	(revision 4765)
@@ -122,6 +122,6 @@
     <value>
         iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8
-        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALEQAA
-        CxEBf2RfkQAAARBJREFUOE9j+P//PwM6Tuh5woxNHJsYhmaQIqABMkDMRIwhWA0onPX8f/zkt0rEGILV
+        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALEAAA
+        CxABrSO9dQAAARBJREFUOE9j+P//PwM6Tuh5woxNHJsYhmaQIqABMkDMRIwhWA0onPX8f/zkt0rEGILV
         gNyZz/4ndN/7HzfhtQYh72A1IGPK0//z9v/+H9Rw8zXQAFt8huAKg/+z9/3637n173+30sv/gQbY4zIE
         qwGRXY/+T9n263/J0r//E6b//W+TexanIVgNCGx++L917XuwZuOSL/+lo6/9N45c9t+h6Gw8ukuwGuBR
@@ -137,6 +137,6 @@
     <value>
         iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8
-        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALEAAA
-        CxABrSO9dQAAAmFJREFUOE+dk21IU1EYx3cVVzkhaLCy+UaY0xwlZkYRmiGR7oMEUlAGfRGKvkRFVOQ0
+        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALDwAA
+        Cw8BkvkDpQAAAmFJREFUOE+dk21IU1EYx3cVVzkhaLCy+UaY0xwlZkYRmiGR7oMEUlAGfRGKvkRFVOQ0
         DddsVmtbvpQWhCFBSvaCUcRAk0gGm8SGM7JtrU1nzYFvu3P33znDRcLpSxceDvdefr/zv+d5Lidaufjg
         QKKIWwNSUo4Tz4u4RAl5xYsgJIuEcADCYlS8oQKLvvvKdam1n+PcqjUyN5ox7PyIVrMB1U9PoKxThZI7
@@ -154,6 +154,6 @@
     <value>
         iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8
-        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALEgAA
-        CxIB0t1+/AAAAN5JREFUOE9j/P//PwNFAGQALuxeeskYnzzYclwKVH3nSpXNefEfaEgEPkOwGgDTPG/f
+        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALEQAA
+        CxEBf2RfkQAAAN5JREFUOE9j/P//PwNFAGQALuxeeskYnzzYclwKVH3nSpXNefEfaEgEPkOwGgDTPG/f
         3/+GYYv+G8ds8MVlCIYByJrz5/7475R35L9WwAKchqAYgKy5dd2//5E9n/57lF38b5+1/7+G31yshqAY
         APJz8cyn/0F07Yr//+Mm//nvX3/vv2bI6v9Aw/+reE4D+gQ10LGGAcgAkAtgBqj7L8LQCDMIpwGTt//9