Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLab.SharpDevelop-3.1.1.5327.csproj
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLab.SharpDevelop-3.1.1.5327.csproj	(revision 4643)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLab.SharpDevelop-3.1.1.5327.csproj	(revision 4775)
@@ -137,8 +137,8 @@
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
-    <Content Include="SharpDevelop License.txt">
+    <Content Include="Mono Cecil License.txt">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
-    <Content Include="Mono License.txt">
+    <Content Include="SharpDevelop License.txt">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs	(revision 4643)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs	(revision 4775)
@@ -28,5 +28,5 @@
   [PluginFile("ICSharpCode.NRefactory.dll", PluginFileType.Assembly)]
   [PluginFile("Mono.Cecil.dll", PluginFileType.Assembly)]
-  [PluginFile("Mono License.txt", PluginFileType.License)]
+  [PluginFile("Mono Cecil License.txt", PluginFileType.License)]
   [PluginFile("SharpDevelop License.txt", PluginFileType.License)]
   [PluginDependency("HeuristicLab.log4net", "1.2.10.0")]
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/Mono Cecil License.txt
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/Mono Cecil License.txt	(revision 4775)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/Mono Cecil License.txt	(revision 4775)
@@ -0,0 +1,22 @@
+﻿Copyright (c) 2008 - 2010, Jb Evain
+
+Permission is hereby granted, free of charge, to any person
+obtaining a copy of this software and associated documentation
+files (the "Software"), to deal in the Software without
+restriction, including without limitation the rights to use,
+copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the
+Software is furnished to do so, subject to the following
+conditions:
+
+The above copyright notice and this permission notice shall be
+included in all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+OTHER DEALINGS IN THE SOFTWARE.
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/Mono License.txt
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/Mono License.txt	(revision 4643)
+++ 	(revision )
@@ -1,22 +1,0 @@
-﻿Copyright (c) <year> <copyright holders>
-
-Permission is hereby granted, free of charge, to any person
-obtaining a copy of this software and associated documentation
-files (the "Software"), to deal in the Software without
-restriction, including without limitation the rights to use,
-copy, modify, merge, publish, distribute, sublicense, and/or sell
-copies of the Software, and to permit persons to whom the
-Software is furnished to do so, subject to the following
-conditions:
-
-The above copyright notice and this permission notice shall be
-included in all copies or substantial portions of the Software.
-
-THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
-OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
-HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
-OTHER DEALINGS IN THE SOFTWARE.