Index: /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.Designer.cs	(revision 4778)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.Designer.cs	(revision 4779)
@@ -54,10 +54,8 @@
       this.contextMenu = new System.Windows.Forms.ContextMenuStrip(this.components);
       this.ShowHideColumns = new System.Windows.Forms.ToolStripMenuItem();
-      this.statusStrip = new System.Windows.Forms.StatusStrip();
-      this.toolStripStatusLabel = new System.Windows.Forms.ToolStripStatusLabel();
+      this.statisticsTextBox = new System.Windows.Forms.TextBox();
       ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).BeginInit();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.contextMenu.SuspendLayout();
-      this.statusStrip.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -96,5 +94,5 @@
       this.dataGridView.Name = "dataGridView";
       this.dataGridView.RowHeadersWidth = 160;
-      this.dataGridView.Size = new System.Drawing.Size(424, 327);
+      this.dataGridView.Size = new System.Drawing.Size(424, 330);
       this.dataGridView.TabIndex = 4;
       this.dataGridView.VirtualMode = true;
@@ -150,19 +148,14 @@
       this.ShowHideColumns.Click += new System.EventHandler(this.ShowHideColumns_Click);
       // 
-      // statusStrip1
+      // statisticsTextBox
       // 
-      this.statusStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.toolStripStatusLabel});
-      this.statusStrip.Location = new System.Drawing.Point(0, 382);
-      this.statusStrip.Name = "statusStrip1";
-      this.statusStrip.Size = new System.Drawing.Size(424, 22);
-      this.statusStrip.TabIndex = 5;
-      this.statusStrip.Text = "statusStrip1";
-      // 
-      // toolStripStatusLabel
-      // 
-      this.toolStripStatusLabel.Name = "toolStripStatusLabel";
-      this.toolStripStatusLabel.Size = new System.Drawing.Size(378, 17);
-      this.toolStripStatusLabel.Spring = true;
+      this.statisticsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.statisticsTextBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
+      this.statisticsTextBox.Location = new System.Drawing.Point(3, 388);
+      this.statisticsTextBox.Name = "statisticsTextBox";
+      this.statisticsTextBox.Size = new System.Drawing.Size(418, 13);
+      this.statisticsTextBox.TabIndex = 5;
+      this.statisticsTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
       // 
       // StringConvertibleMatrixView
@@ -170,10 +163,10 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.statusStrip);
+      this.Controls.Add(this.columnsTextBox);
       this.Controls.Add(this.dataGridView);
-      this.Controls.Add(this.columnsTextBox);
       this.Controls.Add(this.rowsTextBox);
       this.Controls.Add(this.columnsLabel);
       this.Controls.Add(this.rowsLabel);
+      this.Controls.Add(this.statisticsTextBox);
       this.Name = "StringConvertibleMatrixView";
       this.Size = new System.Drawing.Size(424, 404);
@@ -181,6 +174,4 @@
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.contextMenu.ResumeLayout(false);
-      this.statusStrip.ResumeLayout(false);
-      this.statusStrip.PerformLayout();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -197,6 +188,5 @@
     protected System.Windows.Forms.ToolStripMenuItem ShowHideColumns;
     protected System.Windows.Forms.DataGridView dataGridView;
-    private System.Windows.Forms.StatusStrip statusStrip;
-    private System.Windows.Forms.ToolStripStatusLabel toolStripStatusLabel;
+    protected System.Windows.Forms.TextBox statisticsTextBox;
 
   }
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 4778)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 4779)
@@ -510,5 +510,5 @@
 
     private void UpdateVisibilityOfStatisticalInformation() {
-      statusStrip.Visible = showStatisticalInformation;
+      statisticsTextBox.Visible = showStatisticalInformation;
       UpdateDataGridViewSizeAndLocation();
     }
@@ -521,10 +521,11 @@
       dataGridView.Location = new Point(0, offset);
 
-      int statusStripHeight = showStatisticalInformation ? statusStrip.Height : 0;
-      dataGridView.Size = new Size(Size.Width, Size.Height - offset - statusStripHeight);
+      int statisticsTextBoxHeight = showStatisticalInformation ? statisticsTextBox.Height + statisticsTextBox.Margin.Top + statisticsTextBox.Margin.Bottom : 0;
+      dataGridView.Size = new Size(Size.Width, Size.Height - offset - statisticsTextBoxHeight);
     }
 
     private void dataGridView_SelectionChanged(object sender, EventArgs e) {
-      toolStripStatusLabel.Text = string.Empty;
+      string stringFormat = "{0,20:0.0000}";
+      statisticsTextBox.Text = string.Empty;
       if (dataGridView.SelectedCells.Count > 1) {
         List<double> selectedValues = new List<double>();
@@ -536,12 +537,12 @@
         if (selectedValues.Count > 1) {
           StringBuilder labelText = new StringBuilder();
-          labelText.Append("Count: " + selectedValues.Count + "    ");
-          labelText.Append("Sum: " + selectedValues.Sum() + "    ");
-          labelText.Append("Min: " + selectedValues.Min() + "    ");
-          labelText.Append("Max: " + selectedValues.Max() + "    ");
-          labelText.Append("Average: " + selectedValues.Average() + "    ");
-          labelText.Append("Standard Deviation: " + selectedValues.StandardDeviation() + "    ");
-
-          toolStripStatusLabel.Text = labelText.ToString();
+          labelText.Append("Count: " + string.Format(stringFormat, selectedValues.Count) + "    ");
+          labelText.Append("Sum: " + string.Format(stringFormat, selectedValues.Sum()) + "    ");
+          labelText.Append("Min: " + string.Format(stringFormat, selectedValues.Min()) + "    ");
+          labelText.Append("Max: " + string.Format(stringFormat, selectedValues.Max()) + "    ");
+          labelText.Append("Average: " + string.Format(stringFormat, selectedValues.Average()) + "    ");
+          labelText.Append("Standard Deviation: " + string.Format(stringFormat, selectedValues.StandardDeviation()) + "    ");
+
+          statisticsTextBox.Text = labelText.ToString();
         }
       }