Index: branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/HeuristicLab.Services.Authentication.TestClient.csproj
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/HeuristicLab.Services.Authentication.TestClient.csproj	(revision 4740)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/HeuristicLab.Services.Authentication.TestClient.csproj	(revision 4789)
@@ -64,8 +64,4 @@
       <Name>HeuristicLab.Services.Authentication.DataTransfer</Name>
     </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.Services.Authentication\HeuristicLab.Services.Authentication.csproj">
-      <Project>{FF763830-EE9B-4FF7-9A55-4E2552E20C9A}</Project>
-      <Name>HeuristicLab.Services.Authentication</Name>
-    </ProjectReference>
   </ItemGroup>
   <ItemGroup>
Index: branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/Properties/DataSources/HeuristicLab.Services.Authentication.DataTransfer.Application.datasource
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/Properties/DataSources/HeuristicLab.Services.Authentication.DataTransfer.Application.datasource	(revision 4789)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/Properties/DataSources/HeuristicLab.Services.Authentication.DataTransfer.Application.datasource	(revision 4789)
@@ -0,0 +1,10 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<!--
+    This file is automatically generated by Visual Studio .Net. It is 
+    used to store generic object data source configuration information.  
+    Renaming the file extension or editing the content of this file may   
+    cause the file to be unrecognizable by the program.
+-->
+<GenericObjectDataSource DisplayName="Application" Version="1.0" xmlns="urn:schemas-microsoft-com:xml-msdatasource">
+   <TypeInfo>HeuristicLab.Services.Authentication.DataTransfer.Application, HeuristicLab.Services.Authentication.DataTransfer, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null</TypeInfo>
+</GenericObjectDataSource>
Index: branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.Designer.cs
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.Designer.cs	(revision 4740)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.Designer.cs	(revision 4789)
@@ -49,5 +49,5 @@
             this.userNameDataGridViewTextBoxColumn = new System.Windows.Forms.DataGridViewTextBoxColumn();
             this.isAnonymousDataGridViewCheckBoxColumn = new System.Windows.Forms.DataGridViewCheckBoxColumn();
-            this.Membership = new System.Windows.Forms.DataGridViewTextBoxColumn();
+           
             this.bsUsers = new System.Windows.Forms.BindingSource(this.components);
             this.tcUser = new System.Windows.Forms.TabControl();
@@ -290,6 +290,5 @@
             this.dgvUsers.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
             this.userNameDataGridViewTextBoxColumn,
-            this.isAnonymousDataGridViewCheckBoxColumn,
-            this.Membership});
+            this.isAnonymousDataGridViewCheckBoxColumn});
             this.dgvUsers.DataSource = this.bsUsers;
             this.dgvUsers.Location = new System.Drawing.Point(3, 45);
@@ -311,12 +310,5 @@
             this.isAnonymousDataGridViewCheckBoxColumn.HeaderText = "IsAnonymous";
             this.isAnonymousDataGridViewCheckBoxColumn.Name = "isAnonymousDataGridViewCheckBoxColumn";
-            // 
-            // Membership
-            // 
-            this.Membership.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
-            this.Membership.DataPropertyName = "Membership.Email";
-            this.Membership.HeaderText = "EMail";
-            this.Membership.Name = "Membership";
-            this.Membership.Width = 58;
+          
             // 
             // bsUsers
@@ -356,12 +348,5 @@
             this.tabPage3.Text = "Detail";
             this.tabPage3.UseVisualStyleBackColor = true;
-            // 
-            // passwordSaltTextBox
-            // 
-            this.passwordSaltTextBox.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.bsUser, "Membership.PasswordSalt", true));
-            this.passwordSaltTextBox.Location = new System.Drawing.Point(134, 127);
-            this.passwordSaltTextBox.Name = "passwordSaltTextBox";
-            this.passwordSaltTextBox.Size = new System.Drawing.Size(145, 20);
-            this.passwordSaltTextBox.TabIndex = 17;
+           
             // 
             // bsUser
@@ -369,11 +354,5 @@
             this.bsUser.DataSource = typeof(HeuristicLab.Services.Authentication.DataTransfer.User);
             // 
-            // passwordQuestionTextBox
-            // 
-            this.passwordQuestionTextBox.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.bsUser, "PasswordQuestion", true));
-            this.passwordQuestionTextBox.Location = new System.Drawing.Point(134, 73);
-            this.passwordQuestionTextBox.Name = "passwordQuestionTextBox";
-            this.passwordQuestionTextBox.Size = new System.Drawing.Size(145, 20);
-            this.passwordQuestionTextBox.TabIndex = 16;
+
             // 
             // passwordTextBox
@@ -743,5 +722,5 @@
         private System.Windows.Forms.DataGridViewTextBoxColumn userNameDataGridViewTextBoxColumn;
         private System.Windows.Forms.DataGridViewCheckBoxColumn isAnonymousDataGridViewCheckBoxColumn;
-        private System.Windows.Forms.DataGridViewTextBoxColumn Membership;
+
     }
 }
Index: branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.cs
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.cs	(revision 4740)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.cs	(revision 4789)
@@ -31,5 +31,5 @@
             {
 
-               
+
                 RefreshApplicationlist();
             }
@@ -61,8 +61,9 @@
         {
             // show detail
-            if(dgvUsers.SelectedRows.Count == 1){
+            if (dgvUsers.SelectedRows.Count == 1)
+            {
                 User user = (User)dgvUsers.SelectedRows[0].DataBoundItem;
                 bsUser.DataSource = user;
-                bsUserRoles.DataSource = service.GetRolesForUser(user.UserId);
+                bsUserRoles.DataSource = service.GetRolesForUser(user.Id);
                 tcUser.Enabled = false;
             }
@@ -73,8 +74,8 @@
             if (dgvRoles.SelectedRows.Count == 1)
             {
-                Role role = (Role) dgvRoles.SelectedRows[0].DataBoundItem;
+                Role role = (Role)dgvRoles.SelectedRows[0].DataBoundItem;
                 bsRole.DataSource = role;
-                IEnumerable<User> _l = service.GetUsersInRole(role.RoleId);
-                bsRoleUsers.DataSource = service.GetUsersInRole(role.RoleId);
+                IEnumerable<User> _l = service.GetUsersInRole(role.Id);
+                bsRoleUsers.DataSource = service.GetUsersInRole(role.Id);
                 btnDeleteRole.Enabled = true;
                 tcRole.Enabled = true;
@@ -105,17 +106,17 @@
             service.InsertUser(user);
             RefreshUserlist();
-            
+
         }
 
         private void btnSaveRole_Click(object sender, EventArgs e)
         {
-           Role role = (Role)bsRole.DataSource;
-           role.ApplicationId = applicationId;
-           service.InsertRole(role);
-           tcRole.Enabled = false;
-           RefreshRolelist();
+            Role role = (Role)bsRole.DataSource;
+            role.ApplicationId = applicationId;
+            service.InsertRole(role);
+            tcRole.Enabled = false;
+            RefreshRolelist();
         }
 
-       
+
 
         private void btnAddUserToRole_Click(object sender, EventArgs e)
@@ -127,6 +128,6 @@
                 role.ApplicationId = applicationId;
                 user.ApplicationId = applicationId;
-                service.AddUserToRole(role.RoleId, user.UserId);
-                RefreshRoleUserlist(role.RoleId);
+                service.AddUserToRole(role.Id, user.Id);
+                RefreshRoleUserlist(role.Id);
             }
         }
@@ -137,5 +138,5 @@
             {
                 Role role = (Role)dgvRoles.SelectedRows[0].DataBoundItem;
-                service.DeleteRole(role.RoleId);
+                service.DeleteRole(role.Id);
                 RefreshRolelist();
             }
@@ -149,7 +150,7 @@
                 User user = (User)dgvRoleAssignedUsers.SelectedRows[0].DataBoundItem;
                 Role role = (Role)bsRole.DataSource;
-                
-                service.RemoveUserFromRole(role.RoleId, user.UserId);
-                RefreshRoleUserlist(role.RoleId);
+
+                service.RemoveUserFromRole(role.Id, user.Id);
+                RefreshRoleUserlist(role.Id);
             }
         }
@@ -160,5 +161,5 @@
             if (application != null)
             {
-                applicationId = application.ApplicationId;
+                applicationId = application.Id;
                 RefreshApplicationlist();
             }
@@ -173,5 +174,5 @@
                 if (user != null)
                 {
-                    service.DeleteUser(user.UserId);
+                    service.DeleteUser(user.Id);
                     RefreshUserlist();
                 }