Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml	(revision 4733)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml	(revision 4802)
@@ -1,3 +1,4 @@
 ﻿<?xml version="1.0" encoding="utf-8"?><Database Class="ClientManagmentDataContext" xmlns="http://schemas.microsoft.com/linqtosql/dbml/2007">
+  <Connection Mode="AppSettings" ConnectionString="Data Source=.\SQLEXPRESS;Initial Catalog=HeuristicLab.ClientManagment;Integrated Security=True" SettingsObjectName="HeuristicLab.Services.Authentication.DataAccess.Properties.Settings" SettingsPropertyName="ClientManagementConnectionString" Provider="System.Data.SqlClient" />
   <Table Name="" Member="Resources">
     <Type Name="Resource" InheritanceCode="Resource">
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml.layout
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml.layout	(revision 4733)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.dbml.layout	(revision 4802)
@@ -3,14 +3,14 @@
   <DataContextMoniker Name="/ClientManagmentDataContext" />
   <nestedChildShapes>
-    <classShape Id="cace4a80-c7a9-4132-9b82-c4ef3884dbc0" absoluteBounds="0.75, 3.875, 2, 1.9631982421874996">
+    <classShape Id="cace4a80-c7a9-4132-9b82-c4ef3884dbc0" absoluteBounds="0.75, 3.875, 2, 1.7535424804687496">
       <DataClassMoniker Name="/ClientManagmentDataContext/Client" />
       <nestedChildShapes>
-        <elementListCompartment Id="bce42ce5-f605-4c26-a210-ed4ea2812ca7" absoluteBounds="0.765, 4.335, 1.9700000000000002, 1.4031982421875" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+        <elementListCompartment Id="bce42ce5-f605-4c26-a210-ed4ea2812ca7" absoluteBounds="0.765, 4.335, 1.9700000000000002, 1.19354248046875" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
       </nestedChildShapes>
     </classShape>
-    <classShape Id="ea129a98-d63f-4c3a-a3e8-dff64ad53c30" absoluteBounds="2.125, 1.25, 2, 1.5785953776041666">
+    <classShape Id="ea129a98-d63f-4c3a-a3e8-dff64ad53c30" absoluteBounds="2.125, 1.25, 2, 1.424847819010417">
       <DataClassMoniker Name="/ClientManagmentDataContext/Resource" />
       <nestedChildShapes>
-        <elementListCompartment Id="3a656a72-fe83-45a4-87c2-c0aa13fa068f" absoluteBounds="2.14, 1.71, 1.9700000000000002, 1.0185953776041665" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+        <elementListCompartment Id="3a656a72-fe83-45a4-87c2-c0aa13fa068f" absoluteBounds="2.14, 1.71, 1.9700000000000002, 0.86484781901041663" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
       </nestedChildShapes>
     </classShape>
@@ -21,8 +21,8 @@
       </nodes>
     </inheritanceConnector>
-    <classShape Id="7820d3d1-da69-4786-9415-4fa77e5fc03a" absoluteBounds="3.625, 3.875, 2, 0.80938964843749961">
+    <classShape Id="7820d3d1-da69-4786-9415-4fa77e5fc03a" absoluteBounds="3.625, 3.875, 2, 0.76745849609374961">
       <DataClassMoniker Name="/ClientManagmentDataContext/ResourceGroup" />
       <nestedChildShapes>
-        <elementListCompartment Id="125f9904-768c-4c01-9a04-5212a9e6e484" absoluteBounds="3.64, 4.335, 1.9700000000000002, 0.2493896484375" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+        <elementListCompartment Id="125f9904-768c-4c01-9a04-5212a9e6e484" absoluteBounds="3.64, 4.335, 1.9700000000000002, 0.20745849609375" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
       </nestedChildShapes>
     </classShape>
@@ -33,8 +33,8 @@
       </nodes>
     </inheritanceConnector>
-    <classShape Id="9b206f4e-128f-4c3f-bd08-7f2d271ebb2b" absoluteBounds="5.125, 1.25, 2, 1.1939925130208331">
+    <classShape Id="9b206f4e-128f-4c3f-bd08-7f2d271ebb2b" absoluteBounds="5.125, 1.25, 2, 1.0961531575520831">
       <DataClassMoniker Name="/ClientManagmentDataContext/ResourceResourceGroup" />
       <nestedChildShapes>
-        <elementListCompartment Id="9d879183-e5e2-42e9-9fbf-3e68f959d459" absoluteBounds="5.14, 1.71, 1.9700000000000002, 0.63399251302083326" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+        <elementListCompartment Id="9d879183-e5e2-42e9-9fbf-3e68f959d459" absoluteBounds="5.14, 1.71, 1.9700000000000002, 0.53615315755208326" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
       </nestedChildShapes>
     </classShape>
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.designer.cs
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.designer.cs	(revision 4733)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataAccess/ClientManagment.designer.cs	(revision 4802)
@@ -38,4 +38,10 @@
     #endregion
 		
+		public ClientManagmentDataContext() : 
+				base(global::HeuristicLab.Services.Authentication.DataAccess.Properties.Settings.Default.ClientManagementConnectionString, mappingSource)
+		{
+			OnCreated();
+		}
+		
 		public ClientManagmentDataContext(string connection) : 
 				base(connection, mappingSource)
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/ClientService.cs
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/ClientService.cs	(revision 4802)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/ClientService.cs	(revision 4802)
@@ -0,0 +1,85 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Collections;
+using System.Linq;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+using HeuristicLab.Services.Authentication.DataAccess;
+using HeuristicLab.Services.Authentication.DataTransfer;
+using HeuristicLab.Services.Authentication;
+using DA = HeuristicLab.Services.Authentication.DataAccess;
+using DT = HeuristicLab.Services.Authentication.DataTransfer;
+using HLSA = HeuristicLab.Services.Authentication;
+
+
+namespace HeuristicLab.Services.Authentication {
+
+  public class ClientService : IClientService{
+
+
+    private void RemoveRRGEntry(ClientManagmentDataContext cmdc, Guid resID) {
+      foreach (var rrg in cmdc.ResourceResourceGroups.Where(x => x.ResourceId == resID))
+        cmdc.ResourceResourceGroups.DeleteOnSubmit(rrg);
+    }
+
+
+    public DataTransfer.Client GetClient(Guid id) {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<DataTransfer.Client> GetClients() {
+      throw new NotImplementedException();
+    }
+
+    public Guid AddClient(DataTransfer.Client dto) {
+      throw new NotImplementedException();
+    }
+
+    public bool UpdateClient(DataTransfer.Client dto) {
+      throw new NotImplementedException();
+    }
+
+    public bool DeleteClient(DataTransfer.Client dto) {
+      using (ClientManagmentDataContext cmdc = new ClientManagmentDataContext()) {
+        RemoveRRGEntry(cmdc, dto.ResourceID);
+        DA.Resource entity = cmdc.Resources.FirstOrDefault(x => x.Id == dto.ResourceID);
+        if (entity != null) {
+          cmdc.Resources.DeleteOnSubmit(entity);
+          cmdc.SubmitChanges();
+          return true;
+        }
+        return false;
+      }
+    }
+
+    public DataTransfer.ResourceGroup GetResourceGroup(Guid id) {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<DataTransfer.ResourceGroup> GetResourceGroups() {
+      throw new NotImplementedException();
+    }
+
+    public Guid AddResourceGroup(DataTransfer.ResourceGroup dto) {
+      throw new NotImplementedException();
+    }
+
+    public bool UpdateResourceGroup(DataTransfer.ResourceGroup dto) {
+      throw new NotImplementedException();
+    }
+
+    public bool DeleteResourceGroup(DataTransfer.ResourceGroup id) {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<DataTransfer.Resource> GetMembers(Guid id) {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<DataTransfer.Resource> GetRootResources() {
+      throw new NotImplementedException();
+    }
+  }
+}
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.csproj
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.csproj	(revision 4733)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.csproj	(revision 4802)
@@ -74,4 +74,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="ClientService.cs" />
     <Compile Include="Convert.cs" />
     <Compile Include="ClientService.svc.cs">
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/Interfaces/IClientService.cs
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/Interfaces/IClientService.cs	(revision 4733)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication/Interfaces/IClientService.cs	(revision 4802)
@@ -23,5 +23,5 @@
         bool UpdateClient(Client dto);
         [OperationContract]
-        bool DeleteClient(Client id);
+        bool DeleteClient(Client dto);
         #endregion
 